#include <position.h>
#include <ezwin.h>
#include <assert.h>
#include <bitmap.h>

float s,f,u,v;
int S,F,U,V;

int z,m=0,count1=0,flag1=0;
#include"my.h"
//window declaration
SimpleWindow window("The War Chess",16,16,Position(6.0,6.0));
//chess board.
BitMap cb(window);
BitMap* t[2];
BitMap* tp[2];
BitMap* tem;
BitMap* tr;
//BitMap h(window);
//qween.
BitMap wq(window);
BitMap bq(window);

//bishop.
BitMap wb1(window);
BitMap wb2(window);
BitMap bb1(window);
BitMap bb2(window);

//knight.
BitMap wk1(window);
BitMap wk2(window);
BitMap bk1(window);
BitMap bk2(window);

//rook.
BitMap wr1(window);
BitMap wr2(window);
BitMap br1(window);
BitMap br2(window);

//king.
BitMap wking(window);
BitMap bking(window);

//white pawn.
BitMap wp1(window);
BitMap wp2(window);
BitMap wp3(window);
BitMap wp4(window);
BitMap wp5(window);
BitMap wp6(window);
BitMap wp7(window);
BitMap wp8(window);

//black pawn
BitMap bp1(window);
BitMap bp2(window);
BitMap bp3(window);
BitMap bp4(window);
BitMap bp5(window);
BitMap bp6(window);
BitMap bp7(window);
BitMap bp8(window);

//Highlight of all pieces.
BitMap wkingh(window);
BitMap bkingh(window);
BitMap wpah(window);
BitMap bpah(window);
BitMap bbih(window);
BitMap wbih(window);
BitMap bknh(window);
BitMap wknh(window);
BitMap wroh(window);
BitMap broh(window);
BitMap wquh(window);
BitMap bquh(window);

//white and black patches
BitMap white(window);
BitMap black(window);

int windowMouseClick(const Position &p);

int ApiMain()
{
    //Open the window.
window.Open();
assert(window.GetStatus() == WindowOpen);
//h.Load("1.xpm");
//assert(h.GetStatus() == BitMapOkay);
//Position l=Position(16,16);
//h.SetPosition(l);
//h.Draw();

//Load patches
white.Load("white.xpm");
assert(white.GetStatus() == BitMapOkay);
black.Load("black.xpm");
assert(black.GetStatus() == BitMapOkay);

//Load highlighted pieces
wkingh.Load("kiwh.xpm");
assert(wkingh.GetStatus() == BitMapOkay);
bkingh.Load("kibh.xpm");
assert(bkingh.GetStatus() == BitMapOkay);
wpah.Load("pwh.xpm");
assert(wpah.GetStatus() == BitMapOkay);
bpah.Load("pbh.xpm");
assert(bpah.GetStatus() == BitMapOkay);
bbih.Load("bbh.xpm");
assert(bbih.GetStatus() == BitMapOkay);
wbih.Load("bwh.xpm");
assert(wbih.GetStatus() == BitMapOkay);
bknh.Load("kbh.xpm");
assert(bknh.GetStatus() == BitMapOkay);
wknh.Load("kwh.xpm");
assert(wknh.GetStatus() == BitMapOkay);
wroh.Load("rwh.xpm");
assert(wroh.GetStatus() == BitMapOkay);
broh.Load("rbh.xpm");
assert(broh.GetStatus() == BitMapOkay);
wquh.Load("qwh.xpm");
assert(wquh.GetStatus() == BitMapOkay);
bquh.Load("qbh.xpm");
assert(bquh.GetStatus() == BitMapOkay);

//Load images.
cb.Load("chboard.xpm");
assert(cb.GetStatus() == BitMapOkay);
Position p1=Position(0.0,0.0);
cb.SetPosition(p1);
cb.Draw();

wq.Load("queenwhite.xpm");
assert(wq.GetStatus() == BitMapOkay);
Position p2=Position(6.2,14.2);
wq.SetPosition(p2);
wq.Draw();

bq.Load("queenblack.xpm");
assert(bq.GetStatus() == BitMapOkay);
Position p3=Position(6.2,0.2);
bq.SetPosition(p3);
bq.Draw();

wb1.Load("bishopwhite.xpm");
assert(wb1.GetStatus() == BitMapOkay);
Position p4=Position(4.2,14.2);
wb1.SetPosition(p4);
wb1.Draw();

wb2.Load("bishopwhite.xpm");
assert(wb2.GetStatus() == BitMapOkay);
Position p5=Position(10.2,14.2);
wb2.SetPosition(p5);
wb2.Draw();

bb1.Load("bishopblack.xpm");
assert(bb1.GetStatus() == BitMapOkay);
Position p6=Position(4.2,0.2);
bb1.SetPosition(p6);
bb1.Draw();

bb2.Load("bishopblack.xpm");
assert(bb2.GetStatus() == BitMapOkay);
Position p7=Position(10.2,0.2);
bb2.SetPosition(p7);
bb2.Draw();

wk1.Load("knightwhite.xpm");
assert(wk1.GetStatus() == BitMapOkay);
Position p8=Position(2.2,14.2);
wk1.SetPosition(p8);
wk1.Draw();

wk2.Load("knightwhite.xpm");
assert(wk2.GetStatus() == BitMapOkay);
Position p9=Position(12.2,14.2);
wk2.SetPosition(p9);
wk2.Draw();

bk1.Load("knightblack.xpm");
assert(bk1.GetStatus() == BitMapOkay);
Position p10=Position(2.2,0.2);
bk1.SetPosition(p10);
bk1.Draw();

bk2.Load("knightblack.xpm");
assert(bk2.GetStatus() == BitMapOkay);
Position p11=Position(12.2,0.2);
bk2.SetPosition(p11);
bk2.Draw();

wr1.Load("rookwhite.xpm");
assert(wr1.GetStatus() == BitMapOkay);
Position p12=Position(0.2,14.2);
wr1.SetPosition(p12);
wr1.Draw();

wr2.Load("rookwhite.xpm");
assert(wr2.GetStatus() == BitMapOkay);
Position p13=Position(14.2,14.2);
wr2.SetPosition(p13);
wr2.Draw();

br1.Load("rookblack.xpm");
assert(br1.GetStatus() == BitMapOkay);
Position p14=Position(0.2,0.2);
br1.SetPosition(p14);
br1.Draw();

br2.Load("rookblack.xpm");
assert(br2.GetStatus() == BitMapOkay);
Position p15=Position(14.2,0.2);
br2.SetPosition(p15);
br2.Draw();

wking.Load("kingwhite.xpm");
assert(wking.GetStatus() == BitMapOkay);
Position p16=Position(8.2,14.2);
wking.SetPosition(p16);
wking.Draw();

bking.Load("kingblack.xpm");
assert(bking.GetStatus() == BitMapOkay);
Position p17=Position(8.2,0.2);
bking.SetPosition(p17);
bking.Draw();

wp1.Load("pwhite.xpm");
assert(wp1.GetStatus() == BitMapOkay);
Position p18=Position(0.2,12.2);
wp1.SetPosition(p18);
wp1.Draw();

wp2.Load("pwhite.xpm");
assert(wp2.GetStatus() == BitMapOkay);
Position p19=Position(2.2,12.2);
wp2.SetPosition(p19);
wp2.Draw();

wp3.Load("pwhite.xpm");
assert(wp3.GetStatus() == BitMapOkay);
Position p20=Position(4.2,12.2);
wp3.SetPosition(p20);
wp3.Draw();

wp4.Load("pwhite.xpm");
assert(wp4.GetStatus() == BitMapOkay);
Position p21=Position(6.2,12.2);
wp4.SetPosition(p21);
wp4.Draw();

wp5.Load("pwhite.xpm");
assert(wp5.GetStatus() == BitMapOkay);
Position p22=Position(8.2,12.2);
wp5.SetPosition(p22);
wp5.Draw();

wp6.Load("pwhite.xpm");
assert(wp6.GetStatus() == BitMapOkay);
Position p23=Position(10.2,12.2);
wp6.SetPosition(p23);
wp6.Draw();

wp7.Load("pwhite.xpm");
assert(wp7.GetStatus() == BitMapOkay);
Position p24=Position(12.2,12.2);
wp7.SetPosition(p24);
wp7.Draw();

wp8.Load("pwhite.xpm");
assert(wp8.GetStatus() == BitMapOkay);
Position p25=Position(14.2,12.2);
wp8.SetPosition(p25);
wp8.Draw();


bp1.Load("pblack.xpm");
assert(bp1.GetStatus() == BitMapOkay);
Position p26=Position(0.2,2.2);
bp1.SetPosition(p26);
bp1.Draw();

bp2.Load("pblack.xpm");
assert(bp2.GetStatus() == BitMapOkay);
Position p27=Position(2.2,2.2);
bp2.SetPosition(p27);
bp2.Draw();

bp3.Load("pblack.xpm");
assert(bp3.GetStatus() == BitMapOkay);
Position p28=Position(4.2,2.2);
bp3.SetPosition(p28);
bp3.Draw();

bp4.Load("pblack.xpm");
assert(bp4.GetStatus() == BitMapOkay);
Position p29=Position(6.2,2.2);
bp4.SetPosition(p29);
bp4.Draw();

bp5.Load("pblack.xpm");
assert(bp5.GetStatus() == BitMapOkay);
Position p30=Position(8.2,2.2);
bp5.SetPosition(p30);
bp5.Draw();

bp6.Load("pblack.xpm");
assert(bp6.GetStatus() == BitMapOkay);
Position p31=Position(10.2,2.2);
bp6.SetPosition(p31);
bp6.Draw();

bp7.Load("pblack.xpm");
assert(bp7.GetStatus() == BitMapOkay);
Position p32=Position(12.2,2.2);
bp7.SetPosition(p32);
bp7.Draw();

bp8.Load("pblack.xpm");
assert(bp8.GetStatus() == BitMapOkay);
Position p33=Position(14.2,2.2);
bp8.SetPosition(p33);
bp8.Draw();

window.SetMouseClickCallback(windowMouseClick);
}

//mouse click function.
int windowMouseClick(const Position &p)
{
s=p.GetXDistance();
S=s/1.99;

f=p.GetYDistance();
F=(16-f)/1.99;
if(count1%2!=0)
z=1;
else
z=0;

      if(wq.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                       { t[z]=&wq;tp[z]=&wquh;}
 else
      if(bq.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                       { t[z]=&bq;tp[z]=&bquh;}
 else
      if(wb1.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                        { t[z]=&wb1;tp[z]=&wbih;}
 else
     if(wb2.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                       { t[z]=&wb2;tp[z]=&wbih;}
 else
     if(bb1.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                        { t[z]=&bb1;tp[z]=&bbih;}
 else
     if(bb2.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                       { t[z]=&bb2;tp[z]=&bbih;}
 else
     if(wk1.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                       { t[z]=&wk1;tp[z]=&wknh;}
 else
     if(wk2.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                        {t[z]=&wk2;tp[z]=&wknh;}
 else
     if(bk1.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                      {  t[z]=&bk1;tp[z]=&bknh;}
 else
     if(bk2.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                       { t[z]=&bk2;tp[z]=&bknh;}
 else
     if(wr1.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                       { t[z]=&wr1;tp[z]=&wroh;}
 else
     if(wr2.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                       { t[z]=&wr2;tp[z]=&wroh;}
 else
     if(br1.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                        { t[z]=&br1;tp[z]=&broh;}
 else
     if(br2.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                      {  t[z]=&br2;tp[z]=&broh;}
 else
     if(wking.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                        {  t[z]=&wking;tp[z]=&wkingh;}
 else
     if(bking.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                         {  t[z]=&bking;tp[z]=&bkingh;}
 else
     if(wp1.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                       { t[z]=&wp1;tp[z]=&wpah;}
else
    if(wp2.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                     {  t[z]=&wp2;tp[z]=&wpah;}
else
    if(wp3.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                      { t[z]=&wp3;tp[z]=&wpah;}
else
    if(wp4.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                     {  t[z]=&wp4;tp[z]=&wpah;}
else
    if(wp5.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                      { t[z]=&wp5;tp[z]=&wpah;}
else
    if(wp6.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                      { t[z]=&wp6;tp[z]=&wpah;}
else
    if(wp7.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                      { t[z]=&wp7;tp[z]=&wpah;}
else
    if(wp8.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                     {  t[z]=&wp8;tp[z]=&wpah;}
else
    if(bp1.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                      {  t[z]=&bp1;tp[z]=&bpah;}
else
    if(bp2.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                     {  t[z]=&bp2;tp[z]=&bpah;}
else
    if(bp3.IsInside(Position ((S*2+1),(2*(7-F)+1))))

                      { t[z]=&bp3;tp[z]=&bpah;}
else
    if(bp4.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                     {  t[z]=&bp4;tp[z]=&bpah;}
else
    if(bp5.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                     {  t[z]=&bp5;tp[z]=&bpah;}
else
    if(bp6.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                     {  t[z]=&bp6;tp[z]=&bpah;}
else
    if(bp7.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                     {  t[z]=&bp7;tp[z]=&bpah;}
else
    if(bp8.IsInside(Position ((S*2+1),(2*(7-F)+1))))
                     {  t[z]=&bp8;tp[z]=&bpah;}
else 
		{ t[z]=NULL;tp[z]=NULL;}
flag1=0;
int po=chess.movement(U,V,S,F);
if(count1%2!=0)
{
//Castling
	if(po==4)
		{
//castling of white.
			if(F==0 && (S==6 || S==2))
				{
				tp[0]->Erase();
				t[0]->Erase();
				if((U+V)%2==1)
				{
					white.SetPosition(t[0]->GetPosition());
					white.Draw();
				}
				else
				{
					black.SetPosition(t[0]->GetPosition());
					black.Draw();
				}
				t[0]->SetPosition(Position((2*S+0.2),(2*(7-F)+0.2)));
			
				if(S==2)
					{
						wr1.Erase();
						if(((S-2)+F)%2==1)
							{
							white.SetPosition(Position(0.2,14.2));
							white.Draw();
							}
						else
							{
							black.SetPosition(Position(0.2,14.2));
							black.Draw();
							}
						wr1.SetPosition(Position((2*S+2.2),(2*(7-F)+0.2)));
						wr1.Draw();
					}
				else
					{
						wr2.Erase();
						if(((S+1)+F)%2==1)
							{
							white.SetPosition(Position(14.2,14.2));
							white.Draw();
							}
						else
							{
							black.SetPosition(Position(14.2,14.2));
							black.Draw();
							}
						wr2.SetPosition(Position((2*S-1.8),(2*(7-F)+0.2)));
						wr2.Draw();
					}
					t[0]->Draw();
				}//closing for "if" of white rook castling.
//castling of black.
		else if(F==7 &&(S==6 || S==2))
				{
				tp[0]->Erase();
				t[0]->Erase();
				if((U+V)%2==1)
				{
					white.SetPosition(t[0]->GetPosition());
					white.Draw();
				}
				else
				{
					black.SetPosition(t[0]->GetPosition());
					black.Draw();
				}
				t[0]->SetPosition(Position((2*S+0.2),(2*(7-F)+0.2)));
				
				if(S==2)
					{
						br1.Erase();
						if(((S-2)+F)%2==1)
							{
							white.SetPosition(Position(0.2,0.2));
							white.Draw();
							}
						else
							{
							black.SetPosition(Position(14.2,0.2));
							black.Draw();
							}
						br1.SetPosition(Position((2*S+2.2),(2*(7-F)+0.2)));
						br1.Draw();
					}
				else
					{
						br2.Erase();
						if(((S+1)+F)%2==1)
							{
							white.SetPosition(Position(14.2,0.2));
							white.Draw();
							}
						else
							{
							black.SetPosition(Position(14.2,0.2));
							black.Draw();
							}
						br2.SetPosition(Position((2*S-1.8),(2*(7-F)+0.2)));
						br2.Draw();
					}
					t[0]->Draw();
				}//closing of "if" of Black castling.
		}//closing of castling.
//En Passant.
	else if(po==6)
		{
			if((F==(V+1)) && ((S==(U-1)) || (S==(U+1))))
			{

 if(wp1.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                      tr=&wp1;
else
    if(wp2.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                     tr=&wp2;
else
    if(wp3.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                     tr=&wp3;
else
    if(wp4.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                     tr=&wp4;
else
    if(wp5.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                     tr=&wp5;
else
    if(wp6.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                     tr=&wp6;
else
    if(wp7.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                      tr=&wp7;
else
    if(wp8.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                     tr=&wp8;
else
    if(bp1.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                      tr=&bp1;
else
    if(bp2.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                     tr=&bp2;
else
    if(bp3.IsInside(Position ((S*2+1),(2*(7-F)+3))))

                      tr=&bp3;
else
    if(bp4.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                      tr=&bp4;
else
    if(bp5.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                      tr=&bp5;
else
    if(bp6.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                      tr=&bp6;
else
    if(bp7.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                      tr=&bp7;
else
    if(bp8.IsInside(Position ((S*2+1),(2*(7-F)+3))))
                      tr=&bp8;
					tr->Erase();
					if((S+V)%2==1)
						{
						white.SetPosition(tr->GetPosition());
						white.Draw();
						}
					else
						{
						black.SetPosition(tr->GetPosition());
						black.Draw();
						}

					t[0]->Erase();
					if((U+V)%2==1)
						{
						white.SetPosition(t[0]->GetPosition());
						white.Draw();
						}
					else
						{
						black.SetPosition(t[0]->GetPosition());
						black.Draw();
						}
					t[0]->SetPosition(Position((2*S+0.2),(2*(7-F)+0.2)));
					t[0]->Draw();
			}
			else
				if((F==(V-1)) && ((S==(U-1)) || (S==(U+1))))
				{

 if(wp1.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                      tr=&wp1;
else
    if(wp2.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                     tr=&wp2;
else
    if(wp3.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                     tr=&wp3;
else
    if(wp4.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                     tr=&wp4;
else
    if(wp5.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                     tr=&wp5;
else
    if(wp6.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                     tr=&wp6;
else
    if(wp7.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                      tr=&wp7;
else
    if(wp8.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                     tr=&wp8;
else
    if(bp1.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                      tr=&bp1;
else
    if(bp2.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                     tr=&bp2;
else
    if(bp3.IsInside(Position ((S*2+1),(2*(7-V)+1))))

                      tr=&bp3;
else
    if(bp4.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                      tr=&bp4;
else
    if(bp5.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                      tr=&bp5;
else
    if(bp6.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                      tr=&bp6;
else
    if(bp7.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                      tr=&bp7;
else
    if(bp8.IsInside(Position ((S*2+1),(2*(7-V)+1))))
                      tr=&bp8;

					tr->Erase();
					if(((S+V)%2)==1)
						{
						white.SetPosition(tr->GetPosition());

						white.Draw();
						}
					else
						{
						black.SetPosition(tr->GetPosition());

						black.Draw();
						}



					t[0]->Erase();

					if((U+V)%2==1)
						{
						white.SetPosition(t[0]->GetPosition());
						white.Draw();
						}
					else
						{
						black.SetPosition(t[0]->GetPosition());
						black.Draw();
						}
					t[0]->SetPosition(Position((2*S+0.2),(2*(7-F)+0.2)));
					t[0]->Draw();
			}
		}//Closing of "if" of En Passant.
		

	else if(po==1)
	{
		if(t[1]==NULL)
		{
			tp[0]->Erase();
			t[0]->Erase();
			if((U+V)%2==1)
			{
				white.SetPosition(t[0]->GetPosition());
				white.Draw();
			}
			else
			{
				black.SetPosition(t[0]->GetPosition());
				black.Draw();
			}
			t[0]->SetPosition(Position((2*S+0.2),(2*(7-F)+0.2)));
			t[0]->Draw();
		}
		else
		{
			tp[0]->Erase();
			t[0]->Erase();
			t[1]->Erase();
			if((U+V)%2==1)
			{
				white.SetPosition(t[0]->GetPosition());
				white.Draw();
			}
			else
			{
				black.SetPosition(t[0]->GetPosition());
				black.Draw();
			}
			tem=t[1];
			t[0]->SetPosition(t[1]->GetPosition());
			t[0]->Draw();
			t[1]->SetPosition(Position(20.0,20.0));
		}
	}//closing of "if" of any legal move except for special move.
//Illegal Move.
	else
	{

		tp[0]->Erase();
		t[0]->Draw();
		window.Message("Illegal Move");
	}
	count1++;
}//closing of "if" of count even.	
else
{
if(chess.firstclick(S,F))
{	U=S;
	V=F;
tp[0]->SetPosition(t[0]->GetPosition());
tp[0]->Draw();

	count1++;
}
}
return 1;
}




