#include<iostream>
using namespace std;

int castlingb_x[2]={-1,-1};
int castlingb_y[2]={-1,-1};
int castlingw_x[2]={-1,-1};
int castlingw_y[2]={-1,-1};
int enpw_x[2]={-1,-1};//En passant by white pawn
int enpw_y[2]={-1,-1};
int enpb_x[2]={-1,-1};//En passant by black pawn
int enpb_y[2]={-1,-1};
int count=2;
class Type
{
	public:
	
        virtual void legal_moves(int x, int y, int *a, int *b)
	{cout<<"Chess";
	};
};

//Prototypes of all the classes
class Queen : public Type
{
   public:
	void legal_moves(int, int, int *, int *);
}queen;
class King : public Type
{public:
   void legal_moves(int, int, int *, int *);
}king;
class Rook : public Type
{public:
   void legal_moves(int, int, int *, int *);
}rook;
class Knight : public Type
{public:
   void legal_moves(int, int, int *, int *);
}knight;
class Bishop : public Type
{public:
   void legal_moves(int, int, int *, int *);
}bishop;
class Wpawn : public Type
{public:
   void legal_moves(int, int, int *, int *);
}wpawn;
class Bpawn : public Type
{public:
   void legal_moves(int, int, int *, int *);
}bpawn;
class board
{public:
 char colour[8][8],temp_colour,move_colour;
 Type* piece [8][8];Type* temp_piece;Type* move_piece;
 int range_x[8][8][30];
 int range_y[8][8][30];
 int kingposb_x,kingposw_x,kingposb_y,kingposw_y;
 int move_xi,move_yi,move_xf,move_yf;   
int wkflag;//for kings
int bkflag;   
int wlrflag;//for rooks
int wrrflag;
int blrflag;
int brrflag;
 int check_self(int,int,char);
 int check_opp(int,int,char);
 int checkmate();
board();
void range();
int firstclick(int, int);
int movement(int, int, int, int);

}chess;

//Note that the the coordinate values are assumed to be of the type (x,y) in [0,7]
//Let coordinates of knight right now is [x,y]
//The colour can be  either 0,w or b

void Knight::legal_moves(int x, int y, int* a, int* b){
   
     int c=0;
   
//Now i calculate the real number of legalmoves
//1
if(x+2<8 && x+2>-1 && y-1>-1 && y-1<8 && chess.colour[x+2][y-1]!=chess.colour[x][y])
{
    *a=x+2;
    *b=y-1;
     a++;
     b++;
     c++;
}
//2
if(x+2<8 && x+2>-1 && y+1>-1 && y+1<8 && chess.colour[x+2][y+1]!=chess.colour[x][y])
{
    *a=x+2;
    *b=y+1;
     a++;
     b++;
     c++;
}
//3
if(x-2<8 && x-2>-1 && y-1>-1 && y-1<8 && chess.colour[x-2][y-1]!=chess.colour[x][y])
{
    *a=x-2;
    *b=y-1;
     a++;
     b++;
     c++;
}
//4
if(x-2<8 && x-2>-1 && y+1>-1 && y+1<8 && chess.colour[x-2][y+1]!=chess.colour[x][y])
{
    *a=x-2;
    *b=y+1;
     a++;
     b++;
     c++;
}
//5
if(x+1<8 && x+1>-1 && y-2>-1 && y-2<8 && chess.colour[x+1][y-2]!=chess.colour[x][y])
{
    *a=x+1;
    *b=y-2;
     a++;
     b++;
     c++;
}
//6
if(x+1<8 && x+1>-1 && y+2>-1 && y+2<8 && chess.colour[x+1][y+2]!=chess.colour[x][y])
{
    *a=x+1;
    *b=y+2;
     a++;
     b++;
     c++;
}
//7
if(x-1<8 && x-1>-1 && y-2>-1 && y-2<8 && chess.colour[x-1][y-2]!=chess.colour[x][y])
{
    *a=x-1;
    *b=y-2;
     a++;
     b++;
     c++;
}
//8
if(x-1<8 && x-1>-1 && y+2>-1 && y+2<8 && chess.colour[x-1][y+2]!=chess.colour[x][y])
{
    *a=x-1;
    *b=y+2;
     a++;
     b++;
     c++;
}
for(; c<30; c++,a++,b++)

{

*a=-1;

*b=-1;

}
	

};



   void Bishop::legal_moves(int x, int y, int *a, int *b){
   int i=0;
    int j=0;
  int   c=0;
     for(i=x+1,j=y+1; chess.colour[i][j]=='0' && i>-1 && i<8 && j>-1 && j<8;)
    {
        *a=i;
        *b=j;
 i++;j++;a++;b++;c++;  
  }
if(chess.colour[i][j]!=chess.colour[x][y]&&i<8&&i>-1&& j>-1 && j<8)
{
*a=i;
*b=j;
a++;
b++;
c++;
}

    for(i=x-1,j=y+1; chess.colour[i][j]=='0'&& i>-1 && i<8 && j>-1 && j<8; )
    {
        *a=i;
        *b=j;
i--; j++;a++;b++;c++ ;   
}
if(chess.colour[i][j]!=chess.colour[x][y]&&i<8&&i>-1&& j>-1 && j<8)
{
*a=i;
*b=j;
a++;
b++;
c++;
}
    for(i=x-1,j=y-1 ; chess.colour[i][j]=='0'&& i>-1 && i<8 && j>-1 && j<8;)
    {
        *a=i;
        *b=j;
 i--;j--;a++;b++;c++;    
}
if(chess.colour[i][j]!=chess.colour[x][y]&&i<8&&i>-1&& j>-1 && j<8)
{
*a=i;
*b=j;
a++;
b++;
c++;
}
    for(i=x+1,j=y-1; chess.colour[i][j]=='0' && i>-1 && i<8 && j>-1 && j<8; )
    {
        *a=i;
        *b=j;
 i++;j--;a++;b++;c++;
    }
if(chess.colour[i][j]!=chess.colour[x][y]&&i<8&&i>-1&& j>-1 && j<8)
{
*a=i;
*b=j;
a++;
b++;
c++;
}
 for(i=c; i<30;)

{

*a=-1;

*b=-1;
 i++;a++;b++;
}
	

};


  void  Rook::legal_moves(int x, int y, int *a, int *b){
  int  i=0;
    int j=0;
    int c=0;
  for(i=x+1; i<8 && i>-1 && chess.colour[i][y]=='0'; )
    {
            *a=i;
            *b=y;
	i++; a++; b++; c++;    
}
if(chess.colour[i][y]!=chess.colour[x][y]&&i<8&&i>-1)
{
*a=i;
*b=y;
a++;
b++;
c++;
}
   for(i=x-1; i<8 && i>-1 && chess.colour[i][y]=='0'; )
    {
            *a=i;
            *b=y;
	i--; a++; b++; c++;    
}
if(chess.colour[i][y]!=chess.colour[x][y]&&i<8&&i>-1)
{
*a=i;
*b=y;
a++;
b++;
c++;
}
  for(j=y+1; j<8 && j>-1 && chess.colour[x][j]=='0'; )
    {
            *a=x;
            *b=j;
	j++; a++; b++; c++;    
}
if(chess.colour[x][j]!=chess.colour[x][y]&&j<8&&j>-1)
{
*a=x;
*b=j;
a++;
b++;
c++;
}
    for(j=y-1; j<8 && j>-1 && chess.colour[x][j]=='0'; )
    {
            *a=x;
            *b=j;
	j--; a++; b++; c++;    
}
if(chess.colour[x][j]!=chess.colour[x][y]&&j<8&&j>-1)
{
*a=x;
*b=j;
a++;
b++;
c++;
}
     for(i=c; i<30; )

{

*a=-1;

*b=-1;
i++; a++; b++;
}
   
 	
   };
void Queen::legal_moves(int x,int y,int* a,int* b)
{
 int  i=0;
    int j=0;
    int c=0;
 //rook code
   for(i=x+1; i<8 && i>-1 && chess.colour[i][y]=='0'; )
    {
            *a=i;
            *b=y;
	i++; a++; b++; c++;    
}
if(chess.colour[i][y]!=chess.colour[x][y]&&i<8&&i>-1)
{
*a=i;
*b=y;
a++;
b++;
c++;
}
   for(i=x-1; i<8 && i>-1 && chess.colour[i][y]=='0'; )
    {
            *a=i;
            *b=y;
	i--; a++; b++; c++;    
}
if(chess.colour[i][y]!=chess.colour[x][y]&&i<8&&i>-1)
{
*a=i;
*b=y;
a++;
b++;
c++;
}
  for(j=y+1; j<8 && j>-1 && chess.colour[x][j]=='0'; )
    {
            *a=x;
            *b=j;
	j++; a++; b++; c++;    
}
if(chess.colour[x][j]!=chess.colour[x][y]&&j<8&&j>-1)
{
*a=x;
*b=j;
a++;
b++;
c++;
}
    for(j=y-1; j<8 && j>-1 && chess.colour[x][j]=='0'; )
    {
            *a=x;
            *b=j;
	j--; a++; b++; c++;    
}
if(chess.colour[x][j]!=chess.colour[x][y]&&j<8&&j>-1)
{
*a=x;
*b=j;
a++;
b++;
c++;
}
 //bishop code
  for(i=x+1,j=y+1; chess.colour[i][j]=='0' && i>-1 && i<8 && j>-1 && j<8;)
    {
        *a=i;
        *b=j;
 i++;j++;a++;b++;c++;  
  }
if(chess.colour[i][j]!=chess.colour[x][y]&&i<8&&i>-1&& j>-1 && j<8)
{
*a=i;
*b=j;
a++;
b++;
c++;
}

    for(i=x-1,j=y+1; chess.colour[i][j]=='0'&& i>-1 && i<8 && j>-1 && j<8; )
    {
        *a=i;
        *b=j;
i--; j++;a++;b++;c++ ;   
}
if(chess.colour[i][j]!=chess.colour[x][y]&&i<8&&i>-1&& j>-1 && j<8)
{
*a=i;
*b=j;
a++;
b++;
c++;
}
    for(i=x-1,j=y-1 ; chess.colour[i][j]=='0'&& i>-1 && i<8 && j>-1 && j<8;)
    {
        *a=i;
        *b=j;
 i--;j--;a++;b++;c++;    
}
if(chess.colour[i][j]!=chess.colour[x][y]&&i<8&&i>-1&& j>-1 && j<8)
{
*a=i;
*b=j;
a++;
b++;
c++;
}
    for(i=x+1,j=y-1; chess.colour[i][j]=='0' && i>-1 && i<8 && j>-1 && j<8; )
    {
        *a=i;
        *b=j;
 i++;j--;a++;b++;c++;
    }
if(chess.colour[i][j]!=chess.colour[x][y]&&i<8&&i>-1&& j>-1 && j<8)
{
*a=i;
*b=j;
a++;
b++;
c++;
}
    for(i=c; i<30;)

{

*a=-1;

*b=-1;
 i++;a++;b++;
}

}


    void Wpawn::legal_moves(int x,int y,int*a,int*b)
    {
       int  c=0,i=0;
        if(y+1<8 && chess.piece[x][y+1]==NULL)
        {
            *a=x;
            *b=y+1;
            a++;
            b++;
            c++;
        }
        if(y==1 && chess.piece[x][y+1]==NULL && chess.piece[x][y+2]==NULL)
        {
            *a=x;
            *b=y+2;
            a++;
            b++;
            c++;
        }
        if(x+1<8 && y+1<8 && chess.colour[x+1][y+1]=='b')
        {
            *a=x+1;
            *b=y+1;
            a++;
            b++;
            c++;
        }
        if(x-1>-1 && y+1<8 && chess.colour[x-1][y+1]=='b')
        {
            *a=x-1;
            *b=y+1;
            a++;
            b++;
            c++;
        }
	//En Passant       
	 if(chess.move_piece==&bpawn && chess.move_yf==4 && y==4 && chess.move_xf==x-1 && x<8 && chess.move_yi==6)
        {           
 	    *a=x-1;
            *b=5;
	enpw_x[i]=x-1;
	enpw_y[i]=5;
i++;	           
 a++;
            b++;
            c++;
        }
        if(chess.move_piece==&bpawn && chess.move_yf==4 && y==4 && x==chess.move_xf-1 && chess.move_yi==6)
        {
            *a=chess.move_xf;
            *b=5;
	enpw_x[i]=chess.move_xf;
	enpw_y[i]=5;
i++;	
            a++;
            b++;
            c++;
        }
        for(; c<30; c++,a++,b++)
        {
        *a=-1;
        *b=-1;
        }
   };


   void Bpawn::legal_moves(int x,int y,int*a,int*b)
    {
         int c=0,i=0;
        if(y-1>-1 && chess.piece[x][y-1]==NULL)
        {
            *a=x;
            *b=y-1;
            a++;
            b++;
            c++;
        }
        if(y==6 && chess.piece[x][y-1]==NULL && chess.piece[x][y-2]==NULL)
        {
            *a=x;
            *b=y-2;
            a++;
            b++;
            c++;
        }
        if(x+1<8 && y-1>-1 && chess.colour[x+1][y-1]=='w')
        {
            *a=x+1;
            *b=y-1;
            a++;
            b++;
            c++;
        }
        if(x-1>-1 && y-1>-1 && chess.colour[x-1][y-1]=='w')
        {
            *a=x-1;
            *b=y-1;
            a++;
            b++;
            c++;
        }
	//En Passant  
        if(chess.move_piece==&wpawn && chess.move_colour=='w' && chess.move_yf==3 && y==3 && x==chess.move_xf+1 && chess.move_yi==1)
        {
            *a=chess.move_xf;
            *b=2;
	enpb_x[i]=x-1;
	enpb_y[i]=2;
	i++;	                       
a++;
            b++;
            c++;
        }
        if(chess.move_piece==&wpawn && chess.move_colour=='w' && chess.move_yf==3 && y==3 && x==chess.move_xf-1 && chess.move_yi==1)
        {
            *a=chess.move_xf;
            *b=2;
enpb_x[i]=x+1;
	enpb_y[i]=2;
i++;	                       
a++;
            b++;
            c++;
        }
        for(; c<30; c++,a++,b++)
        {
        *a=-1;
        *b=-1;
        }
   
};
           

//Now we firstly define the moves for castling
//Here the king should not be in check at the time
//The squares that the king passes through should not be in the power of any of the opposite pieces
//The rook may be susceptible to attack

void King::legal_moves(int x, int y, int *a, int *b){
int c=0;

int i=0,j=0;

/*Checking whether the two pieces are of same colour and the required types*/
if(x==4 && y==0 && chess.colour[4][0]==chess.colour[7][0] && chess.piece[7][0]==&rook && chess.wkflag==0 && chess.wrrflag==0)
{
//Castling towards right for white
if(chess.check_self(5,0,'w')==0 && chess.check_self(6,0,'w')==0 && chess.colour[5][0]=='0' && chess.colour[6][0]=='0')
{
*a=6;
*b=0;

castlingw_x[i]=6;
castlingw_y[i]=0;
a++;
b++;
c++;
i++;
}
}
//Castling toward right for black
if(x==4 && y==7 && chess.colour[x][y]==chess.colour[x+3][y] && chess.piece[x+3][y]==&rook && chess.bkflag==0 && chess.brrflag==0)
{
if(chess.check_self(x+1,y,'b')==0 && chess.check_self(x+2,y,'b')==0 && chess.colour[x+1][y]=='0' && chess.colour[x+2][y]=='0')
{
*a=6;
*b=7;
castlingb_x[j]=6;
castlingb_y[j]=7;
a++;
b++;
c++;
j++;
}
}
if(x==4 && y==0 && chess.colour[x][y]==chess.colour[x-4][y] && chess.piece[x-4][y]==&rook && chess.wkflag==0 && chess.wlrflag==0)//Checking whether the two pieces are of same colour and the required types
{
//Castling towards left for white
if(chess.check_self(x-1,y,'w')==0 && chess.check_self(x-2,y,'w')==0 && chess.colour[x-1][y]=='0' && chess.colour[x-2][y]=='0')
{
*a=2;
*b=0;
castlingw_x[i]=2;
castlingw_y[i]=0;
a++;
b++;
c++;
i++;
}
}
//Castling toward left for black
if(x==4 && y==7 && chess.colour[x][y]==chess.colour[x-4][y] && chess.piece[x-4][y]==&rook && chess.bkflag==0 && chess.blrflag==0)
{
if(chess.check_self(x-1,y,'b')==0 && chess.check_self(x-2,y,'b')==0 && chess.colour[x-1][y]=='0' && chess.colour[x-2][y]=='0')
{
*a=2;
*b=7;
castlingb_x[j]=2;
castlingb_y[j]=7;
a++;
b++;
c++;
j++;
}
}

	if(x+1<8&&chess.colour[x+1][y]!=chess.colour[x][y])
	{
		*a=x+1;
		*b=y;
		a++;
		b++;
		c++;
	}  
	if(x+1<8&& y+1<8&&chess.colour[x+1][y+1]!=chess.colour[x][y])
	{
		*a=x+1;
		*b=y+1;
		a++;
		b++;
		c++;
	}
	if(x+1<8&&y-1>-1&&chess.colour[x+1][y-1]!=chess.colour[x][y])
	{
		*a=x+1;
		*b=y-1;
		a++;
		b++;
		c++;
	} 
	if(y+1<8&&chess.colour[x][y+1]!=chess.colour[x][y])
	{
		*a=x;
		*b=y+1;
		a++;
		b++;
		c++;
	}  
	if(y-1>-1&&chess.colour[x][y-1]!=chess.colour[x][y])
	{
		*a=x;
		*b=y-1;
		a++;
		b++;
		c++;
	}
	if(x-1>-1&&chess.colour[x-1][y]!=chess.colour[x][y])
	{
		*a=x-1;
		*b=y;
		a++;
		b++;
		c++;
	}  
	if(x-1>-1&& y+1<8&&chess.colour[x-1][y+1]!=chess.colour[x][y])
	{
		*a=x-1;
		*b=y+1;
		a++;
		b++;
		c++;
	}
	if(x-1>-1&&y-1>-1&&chess.colour[x-1][y-1]!=chess.colour[x][y])
	{
		*a=x-1;
		*b=y-1;
		a++;
		b++;
		c++;
	} 
   for(i=c; i<30; )

    {

        *a=-1;
        *b=-1;
	i++;a++;b++;

    }
	
};
int board::check_self(int a,int b,char c) {
int x,y;
 		for(x=0;x<8;x++){
		for(y=0;y<8;y++){
	
			if (colour[x][y]!=c  && piece[x][y]!=NULL ){
				for(int i=0;i<30;i++){
				if (range_x[x][y][i]==a){ if (range_y[x][y][i]==b){return 1;}}
				}
			}
	}
	}
return 0;
}
int board::check_opp(int a,int b,char c) {
int x,y;
 	
	for(x=0;x<8;x++){
		for(y=0;y<8;y++){
		if (colour[x][y]!= c && piece[x][y]!=NULL){
			for(int i=0;i<30;i++){
			if (range_x[x][y][i]==a){ if (range_y[x][y][i]==b){return 1;}}
			}
		}
	}
}
return 0;
}
board::board()
 {
int x,y;
  kingposw_x=4;
  kingposw_y=0;
  kingposb_x=4;
  kingposb_y=7;
    

wkflag=0;//for kings
bkflag=0;   
wlrflag=0;//for rooks
wrrflag=0;
blrflag=0;
brrflag=0;
move_colour='b';
for(y=0;y==0||y==7;y=y+7)
     {
         for(x=0;x<8;x++)
         {
             if(y==0)colour[x][y]='w';
             else colour[x][y]='b';
             switch(x)

  {
             case 0:
             
                 piece[x][y] =&rook;
                        
                 break;
             
             case 1:
             
                 piece[x][y] =&knight;
                 break;
             
             case 2:
             
                 piece[x][y] =&bishop;
                 
                 break;
             
             case 3:
             
                 piece[x][y] =&queen;
                 break;
             
             case 4:
             
                 piece[x][y] =&king;
                 
                 break;
             
             case 5:
             
                 piece[x][y]=&bishop;
                 
                 break;
             
             case 6:
             
                 piece[x][y] =&knight;
                
                 break;
             
             case 7:
             
                 piece[x][y] =&rook;
                 break;
             }
         }
}
     
         for(x=0;x<8;x++)
         {
             colour[x][1]='w';
             piece[x][1]=&wpawn;
             
         }
     
     y=6;
         for(x=0;x<8;x++)
         {
             colour[x][y]='b';
             piece[x][y]=&bpawn;
             
         }
     
     for(y=2;y<6;y++)
     {
         for(x=0;x<8;x++)
         {
             colour[x][y]='0';
             piece[x][y]=NULL;
         }
     }
 for(y=0;y==0||y==7;y=y+7)
     {
         for(x=0;x<8;x++)
         {
     		piece[x][y]->legal_moves(x,y,&range_x[x][y][0],&range_y[x][y][0]);

		}
}
for(y=1;y==1||y==6;y=y+5)
     {
         for(x=0;x<8;x++)
         {
     		piece[x][y]->legal_moves(x,y,&range_x[x][y][0],&range_y[x][y][0]);

		}
}
}
 void board::range()
 {
int x,y;
      for(x=0;x<8;x++)
     {
         for(y=0;y<8;y++)
         {
         if(piece[x][y]!=NULL)
         piece[x][y]->legal_moves(x,y,&range_x[x][y][0],&range_y[x][y][0]);
         }
     }
 }
 int board::firstclick(int a,int b)
 {
 if(piece[a][b]!=NULL && colour[a][b]!=move_colour)
 return 1;
 else
 return 0;
 }
 int board::movement(int xi,int yi,int xf,int yf)
 {
     int flag=0;
	
     for(int i=0;i<30;i++)
     {
         if(xf==range_x[xi][yi][i] && yf==range_y[xi][yi][i])
         {
             flag++;
             break;
         }
     }
     if(flag==0)
     {return 0;}
	
//     flag=1;
     temp_colour=colour[xf][yf];
     temp_piece=piece[xf][yf];
     colour[xf][yf]=colour[xi][yi];
     piece[xf][yf]=piece[xi][yi];
     colour[xi][yi]='0';
     piece[xi][yi]=NULL;
     range();
 int fw=0;int fb=0;//flags for white and black kings
	if(kingposw_x == xi)
{	if(kingposw_y ==yi){
kingposw_x=xf;kingposw_y=yf;fw=1;}
}
	if(kingposb_x == xi)
{	if(kingposb_y==yi){
kingposb_x=xf;kingposb_y=yf;
fb=1;}
}
     if(count%2==1)
    {
     if(check_self(kingposb_x, kingposb_y, colour[kingposb_x][kingposb_y]))
     {
         colour[xi][yi]=colour[xf][yf];
         piece[xi][yi]=piece[xf][yf];
         colour[xf][yf]=temp_colour;
         piece[xf][yf]=temp_piece;

	if(fw==1){kingposw_x=xi;kingposw_y=yi;}
      if(fb==1){kingposb_x=xi;kingposb_y=yi;}
    range();
	return 0;
	
     }
    }
     if(count%2==0)
    {
     if(check_self(kingposw_x, kingposw_y, colour[kingposw_x][kingposw_y]))
     {
         colour[xi][yi]=colour[xf][yf];
         piece[xi][yi]=piece[xf][yf];
         colour[xf][yf]=temp_colour;
         piece[xf][yf]=temp_piece;
	if(fw==1){kingposw_x=xi;kingposw_y=yi;}
      if(fb==1){kingposb_x=xi;kingposb_y=yi;}
         range();
	 return 0;
     }
    }

     count++;
     move_xi=xi;
     move_yi=yi;
     move_xf=xf;
     move_yf=yf;
     move_colour=colour[xf][yf];
     move_piece=piece[xf][yf];
    cout<<move_xi<<"\t"<<move_yi<<"\tto\t"<<move_xf<<"\t"<<move_yf<<endl;
     range();

//As modified for castling

if(move_piece==&king && move_colour=='w')
{

    wkflag=1;

}

if(move_piece==&king && move_colour=='b')
{

    bkflag=1;

}

if(move_piece==&rook && move_colour=='w' && xi==0 )
{

    wlrflag=1;

}
//

if(move_piece==&rook && move_colour=='w' && xi==7 )
{

    wrrflag=1;

}
if(move_piece==&rook && move_colour=='b' && xi==0)
{

    blrflag=1;

}
if(move_piece==&rook && move_colour=='b' && xi==7)
{

    brrflag=1;

}
//Moving rook in case of castling
if(move_piece==&king)
{

for(int p=0; p<2; p++)

{

    if(xf==castlingw_x[ p] && yf==castlingw_y[p])

    { 

if(xf==6 && yf==0)

{
                     colour[5][0]=colour[7][0];
                         piece[5][0]=piece[7][0];
                         colour[7][0]='0';
                         piece[7][0]=NULL;        
			return 4;      }
					
if(xf==2 && yf==0)

{
                         colour[3][0]=colour[0][0];
                         piece[3][0]=piece[0][0];
                         colour[0][0]='0';
                         piece[0][0]=NULL;
                        return 4;       }
}
}
}
for(int p=0; p<2; p++)

{

    if(xf==castlingb_x[ p] && yf==castlingb_y[p])

    { 

if(xf==6 && yf==7)

{  			colour[5][7]=colour[7][7];
                         piece[5][7]=piece[7][7];
                         colour[7][7]='0';
                         piece[7][7]=NULL;
			return 4;	
                        }

if(xf==2 && yf==7)

{
                  colour[3][7]=colour[0][7];
                         piece[3][7]=piece[0][7];
                         colour[0][7]='0';
                         piece[0][7]=NULL;
			return 4;
        }

    }

}


//Removing the other pawn in case of En Passant
//The case of white pawn performing En Passant on the black pawn
if(move_piece==&wpawn)
{
for(int p=0; p<2; p++)

{

    if(xf==enpw_x[p] && yf==enpw_y[p])

    {

	//	colour[xf][yf]=colour[xi][yi];
	//	piece[xf][yf]=piece[xi][yi];
	//	colour[xi][yi]='0';
	//	piece[xi][yi]=NULL;
		colour[xf][4]='0';
		piece[xf][4]=NULL;
		return 6;
}
}
}
//The case of black pawn performing En Passant on the white pawn
if(move_piece==&bpawn)
{
for(int p=0; p<2; p++)

{

    if(xf==enpb_x[p] && yf==enpb_y[p])

    {

		//colour[xf][yf]=colour[xi][yi];
	//	piece[xf][yf]=piece[xi][yi];
	//	colour[xi][yi]='0';
	//	piece[xi][yi]=NULL;
		colour[xf][3]='0';
		piece[xf][3]=NULL;
		return 6;
}
}
}

return 1;
};
  /*   if(count%2==0)
     {if(!(check_opp(kingposb_x,kingposb_y,'b')))
     return 1;
     }
    if(count%2==1)
    {if(!(check_opp(kingposw_x,kingposw_y,'w')))
     return 1;
     }
*/
/*if(checkmate())
     return 2;
     else
     return 1;
*/ 


#include"checkmate.h"
